ECHO off
REM Bubble-Creator 
REM Made by JackDole
REM For SE 0.990
REM 2016.08.24 22:13:29

REM Set here the path to the destinaton
SET SE_CATALOGS=%~dp0
REM SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!MegaStructures\!Dyson\catalogs\planets

SET TidalLocked=NIL
rem //TidalLocked	true
SET daysYear=365.24218985
SET Oblateness=0
SET oOffset=0
SET rings=1
SET collectors=120
SET coldivisor=1
SET defPeriod=1000000
SET radius=0
SET cenRad=500
SET mCM3=0.0000000000001
SET defInc=0
SET angle=0
SET AngularDiameter=3
SET Randomize=(-0.381, 0.984, -1.111)
SET RefPlane=Equator

SET Albedo=0.9
SET Color=(0.3 0.3 0.1)
SET GlowColor=(1.00 0.06 0.26)

SET DiffMap=DiffMap         "Collector02.*"
SET GlowMap=GlowMap         "Collector02.*"
SET DiffMapAlpha=NIL
rem DiffMapAlpha    "Ice"

SET Disc=""
rem Collector
SET Object=Asteroid
SET Class=Asteroid

SET pi=3.14159265
SET mSol=1.9891e+030
SET mEarth=5.9736e+024
SET RingOrbit=421570
SET pDist=500
SET mProx=2.446e+029
SET mBetg=1.531e+031
SET mAlde=3.381e+030
SET AU=149597870.691
SET distAu=1.2

SET NoClouds=true
SET NoOcean=true
SET NoLava=true
SET NoAtmosphere=true
SET NoAurora=true
SET NoRings=true
SET NoCometTail=true
SET NoLighting=false
Set NameHead=Default

SET GlowMode="Thermal"
SET GlowBright=0.5
rem 0.025
SET BumpMap=NIL
SET PosPolar=(0.0 0.0 0.0)

REM Select a predefined set or 'REM' it out
rem Goto Earth
Goto Proxima
REM GOTO Sol
REM Goto BlackRose
REM GOTO Dhanda
rem GOTO Matri
rem Goto Ebony
rem GOTO inDhanda

REM ********************
REM *** DEFINE THIS  !!! ***
REM ********************
REM Path to catalogs folder
    rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!MegaStructures\!Dyson\catalogs\planets
    REM SET SE_CATALOGS=%SPACEENGINES%\catalogs\planets
REM Set this 'true' if the collectors should be like planet rings - will be ignored by Type = Rings
    SET RingCollector=false
REM Define Type:  'Ring' or 'Bubble' - Default = Bubble
    Rem SET oType=Ring
    SET oType=Bubble
REM Name of the center object or 'Default'  = Earth  if oType=Ring or Sol if oType=Bubble
    SET Center=Null Hole B
    Set NameHead=Cube
    rem SET Center=Default
Rem Mass of the center object  in kg - 0 = Default = mEarth or mSol
    SET cMass=2.022720696e+024
    rem 2.38692e+050
    rem %mSol%
REM SemiMajorAxis	KM -  If this is > 0 'distAU' will be ignored
    SET distKm=10
    rem 179517444.8292
REM SemiMajorAxis	AU - will be ignored if Type = Ring
    SET distAu=0
    rem 135
    rem 1.2
REM Define RefPlane - Equator or Ecliptic
    rem SET RefPlane=Ecliptic
    SET RefPlane=Equator
REM will be ignored byy oType=Ring
    SET rings=2
    SET collectors=4
    SET AngularDiameter=3
    Set Oblateness=0
    SET DiffMap=DiffMap        "Collector02x.*"
    SET GlowMap=GlowMap        "Collector02x.*"
    rem 3.01
REM Albedo + Color
    SET Albedo=0.9
    SET Color=(0.3 0.3 0.1)
REM ********************
REM ********************
REM ********************
GOTO Junction

REM PREDEFINED SETS
:BlackRose
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.974\addons\catalogs\planets\JDV\BR
SET RingCollector=false
SET oType=Bubble
SET Center=Tricycle
Set NameHead=BlackRose
SET Disc=WeaponsPlatform
SET mCM3=1.0
SET cMass=1.063730898e+031
SET distKm=10000000
SET distAu=20
SET RefPlane=Equator
SET rings=15
SET collectors=30
rem SET radius=1000
SET AngularDiameter=0.3
Set defPeriod=1000000
SET Albedo=0.0
SET Color=(0.0 0.0 0.5)
Set Oblateness=0.9
SET DiffMap=DiffMap        "FieldGen.*"
SET GlowMap=GlowMap        "FieldGen.*"
rem GlowMap        "DoCa01.*"
Goto Junction

:Sol
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!MegaStructures\!Dyson\catalogs\planets
SET RingCollector=false
SET oType=Bubble
SET Center=Sol
Set NameHead=Sol
SET cMass=%mSol%
SET distKm=0
SET distAu=1.2
SET RefPlane=Equator
SET rings=15
SET collectors=30
SET AngularDiameter=3
SET Albedo=0.1
SET Color=(0.0 0.0 0.1)
Set Oblateness=0
SET DiffMap=DiffMap        "Collector02.*"
SET GlowMap=GlowMap        "Collector02.*"
Goto Junction

:Earth
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!MegaStructures\!Dyson\catalogs\planets
SET oType=Ring
SET Center=Earth
Set NameHead=Earth
SET cMass=%mEarth%
SET pDist=550
SET distKm=421570
SET distAu=0
SET RefPlane=Equator
SET Albedo=0.9
SET Color=(0.3 0.3 0.1)
Set Oblateness=0
Goto Junction

:Proxima
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.974\addons\catalogs\planets\Proxima
SET RingCollector=false
SET oType=Bubble
SET Center=Proxima
Set NameHead=Proxima
SET cMass=%mProx%
SET distKm=0
SET distAu=0.06
rem 0.012
SET RefPlane=Equator
SET rings=8
rem 12
SET collectors=16
rem 24
SET AngularDiameter=0
rem 12
Set Oblateness=0
SET DiffMap=DiffMap        "hexagon.*"
rem "Collector02.*"
SET GlowMap=GlowMap        "Glow-Light.*"
rem "Collector02.*"
SET DiffMapAlpha=DiffMapAlpha    "Transp"
SET GlowMode="Night"
SET GlowBright=2.5
rem 0.25
Goto Junction

REM ----------------------------------------------------------------------------
REM D'handa Lyonitas C
:Dhanda
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!JDV\Wunderwelt\catalogs\planets
SET RingCollector=false
SET oType=Bubble
SET Center=D'handa Lyonitas C
Set NameHead=WoW-Dhanda-
SET cMass=1.9523772358e+29
rem %mProx%
SET distKm=0
SET distAu=0.035
rem 0.015
rem SET RefPlane=Extrasolar
SET RefPlane=Equator
SET rings=12
rem 15
SET collectors=24
rem 30
SET AngularDiameter=0
rem 10.61
rem 3
Set Oblateness=0.999

SET DiffMap=DiffMap        "WoW/Bubble/solarpanel_diff.*"
SET BumpMap=BumpMap        "WoW/Bubble/solarpanel_bump.*"
SET GlowMap=GlowMap        "WoW/Bubble/panel_glow.*"
rem SET DiffMap=DiffMap        "WoW/Bubble/panel-III_diff.*"
rem SET BumpMap=BumpMap        "WoW/Bubble/panel-III_bump.*"
rem SET GlowMap=GlowMap        "WoW/Bubble/panel-II_glow.*"
rem SET DiffMap=DiffMap        "WoW/Bubble/panel-IIIb_diff.*"
rem SET BumpMap=BumpMap        "WoW/Bubble/panel-IIIb_bump.*"
rem SET GlowMap=GlowMap        "WoW/Bubble/panel-IIIb_diff.*"

SET DiffMapAlpha=DiffMapAlpha    "Transp"
SET GlowMode="Night"
SET GlowBright=0.5
rem 0.125

rem SET DiffMap=DiffMap        "NONE"
rem SET BumpMap=BumpMap        "WoW/Bubble/shield_bump.*"
rem SET GlowMap=GlowMap        "WoW/Bubble/GlowLight01.*"

rem SET DiffMap=NIL
rem SET BumpMap=NIL
rem SET GlowMap=NIL
rem SET Class=Terra

SET NoLighting=false

Goto Junction

REM ----------------------------------------------------------------------------
REM Matri
:Matri
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!JDV\Wunderwelt\catalogs\planets
SET RingCollector=false
SET oType=Bubble
SET Center=Matri
Set NameHead=Matri-Dyson-
SET cMass=1.1198633e30
rem %mProx%
SET distKm=0
SET distAu=0.35
rem 0.040
rem 0.35
rem SET RefPlane=Extrasolar
SET RefPlane=Equator
SET rings=12
SET collectors=24
SET AngularDiameter=4
rem 10.61
rem 3
Set Oblateness=0.999
rem SET /a oOffset=90/%rings%

SET DiffMap=DiffMap        "WoW/Matruska/MatruskaDarkBlack.*"
SET BumpMap=BumpMap        "WoW/Matruska/MatruskaBump.*"
SET GlowMap=GlowMap        "WoW/Matruska/MatruskaGlow.*"

SET DiffMapAlpha=DiffMapAlpha    "Transp"
SET GlowMode="Night"
SET GlowBright=0.125
rem 0.25
REM 0.125
SET GlowColor=(1.00 1.00 1.00)

SET NoLighting=false

Goto Junction

REM ----------------------------------------------------------------------------
REM Black City
:Ebony
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!JDV\Wunderwelt\catalogs\planets
SET RingCollector=false
SET oType=Bubble
SET Center=JDV X0005 A
Set NameHead=Ebony-Yellow-
SET cMass=4.972750000000000e30
rem %mProx%
SET distKm=2900
SET distAu=0
rem 0.040
rem 0.35
rem SET RefPlane=Extrasolar
SET RefPlane=Equator
SET rings=9
SET collectors=18
SET AngularDiameter=0
rem 4
rem 10.61
rem 3
Set Oblateness=0.9
rem 99
rem SET /a oOffset=90/%rings%

SET DiffMap=DiffMap        "WoW/Matruska/MatruskaYellow.*"
SET BumpMap=BumpMap        "WoW/Matruska/MatruskaBump.*"
SET GlowMap=GlowMap        "WoW/Matruska/MatruskaGlow.*"

SET DiffMapAlpha=DiffMapAlpha    "Transp"
SET GlowMode="Night"
SET GlowBright=0.25
rem 0.25
REM 0.125
SET GlowColor=(1.00 1.00 1.00)

SET NoLighting=false

Goto Junction

:inDhanda
rem SET SE_CATALOGS=%SPACEENGINES%\SpaceEngine 0.980\addons\!JDV\Wunderwelt\catalogs\planets
SET RingCollector=false
SET oType=Bubble
SET Center=D'handa Lyonitas C
Set NameHead=WoW-DhandaTerre
SET cMass=1.9523772358e+29
SET distKm=0
SET distAu=0.034993315412877
SET RefPlane=Equator
SET rings=12
SET collectors=24
SET AngularDiameter=18
Set Oblateness=0.999
SET DiffMap=NIL
SET BumpMap=NIL
SET GlowMap=NIL
SET DiffMapAlpha=NIL

SET NoOcean=false
SET Class=Terra

Goto Junction

REM END OF PREDEFINE SETS


:Junction
REM To Ring or not to Ring
echo.%SE_CATALOGS%

IF /i "%RingCollector%" EQU "true" SET Oblateness=0.9
SET POS=Innen
IF /i "%oType%" EQU "Ring" Goto TheRing
Goto Bubble


:TheRing
ECHO TheRing

IF /i "%Center%" EQU "Default" (
    SET Dyson=Earth
) ELSE (
    SET Dyson=%Center%
)

IF /i "%NameHead%" EQU "Default" (
    SET DysonBubble=%Dyson%%POS%RinG
) ELSE (
    SET DysonBubble=%NameHead%%POS%RinG
)

SET Disc=%Dyson%%POS%RingPanel
SET TidalLocked=TidalLocked     false

IF %cMass% EQU 0 (
    SET Mass1=%mEarth%
) ELSE (
    SET Mass1=%cMass%
)

SET distAU=0

SET RingCollector=false
SET NoClouds=false
SET NoOcean=false
SET NoLava=true
SET NoAtmosphere=false
SET NoAurora=false
SET NoRings=true
SET NoCometTail=true
SET rings=1
SET collectors=120
SET AngularDiameter=3.01

SET DiffMap=DiffMap        "black.*"
SET Oblateness=0.9

IF %distKm% EQU 0 SET distKm=%RingOrbit%

IF /i "%POS%" EQU "Innen" (
    REM Lua lcalc.lua 500/%RingOrbit%*%distKm% > result.txt
    REM SET /p pDist= < result.txt
    SET mCM3=0.03
    SET DiffMap=NIL
    SET GlowMap=NIL
    SET Object=Moon
    SET Class=Terra
) ELSE (
    SET mCM3=0.000001
    SET DiffMap=DiffMap        "Collector02.*"
    SET GlowMap=GlowMap        "Collector02.*"
    SET Object=Asteroid
    SET Class=Asteroid
    SET Oblateness=0
)

Lua lcalc.lua %distKm%-%pDist% > result.txt
SET /p distKm= < result.txt

IF /I "%POS%" EQU "Aussen" Goto allDone
    Lua lcalc.lua %distKm%/%AU% > result.txt
    SET /p a= < result.txt
    Lua lcalc.lua int(3.12*%a%*%AU%*%AngularDiameter%/360) > result.txt
    SET /p radius= < result.txt
    Lua lcalc.lua (4/3*%pi%*(%radius%*1000*100)^^3*(1-%Oblateness%)*%mCM3%) > result.txt
    SET /p Mass2= < result.txt
    Lua lcalc.lua sqrt(%a%^^3/(%Mass1%/%mSol%+%Mass2%/%mSol%)) > result.txt
    SET /p defPeriod= < result.txt
:allDone

SET FileName=%DysonBubble%
rem _%collectors%x%rings%
Echo %FileName%
GOTO FileHead

:Bubble
IF /i "%Center%" EQU "Default" (
    SET Dyson=Sol
) ELSE (
    SET Dyson=%Center%
)

ECHO %DYSON% BUBBLE

IF /i "%NameHead%" EQU "Default" (
    SET DysonBubble=%Dyson%Bubble
) ELSE (
    SET DysonBubble=%NameHead%Bubble
)

if /i %Disc% EQU "" SET Disc=%Dyson% Mirror

REM SET TidalLocked=TidalLocked     true
SET TidalLocked=NIL

If /i "%distAU%" EQU "0" SET distAU=1.2

IF /i %cMass% EQU 0 (
    SET Mass1=%mSol%
) ELSE (
    SET Mass1=%cMass%
)


If %rings% EQU 0 SET rings=18
IF %collectors% EQU 0 SET collectors=36

SET FileName=%DysonBubble%_%collectors%x%rings%
GOTO FileHead

:filehead
REM SET /a numOfCollectors=1
SET /a rings=%rings%*2

IF /i "%RingCollector%" EQU "true" (
    SET FileName=RC_%FileName%
    SET DiffMap=DiffMap        "black.*"
)
rem ECHO.// -*- coding: utf-8 -*->%FileName%.sc
ECHO.// %FileName%.sc>%FileName%.sc
ECHO.// Made with Bubble-Creator by JackDole>>%FileName%.sc
ECHO.// %DATE% %TIME% >>%FileName%.sc
ECHO.>>%FileName%.sc

SET numb=1
SET /a iOff=360/%rings%
SET rloop=0
IF %angle% EQU 0 (
    Lua lcalc.lua 360/%collectors% > result.txt
    SET /p angle= < result.txt
)
echo An %angle%
SET idx=1
SET dots=.
SET distOff=3.34229356e-008

SET a=%distAu%

IF %distKm% EQU 0 GOTO skipKmAU
    Lua lcalc.lua %distKm%/%AU% > result.txt
    SET /p a= < result.txt
:skipKmAU
SET aReal=%a%
rem echo A %a%

IF %AngularDiameter% EQU 0 SET /a AngularDiameter=360/%collectors%
echo AD %AngularDiameter%
echo AU %AU%

IF %radius% GTR 0 Goto skipRad
    Lua lcalc.lua int(3.12*%a%*%AU%*%AngularDiameter%/360) > result.txt
    SET /p radius= < result.txt
:skipRad
IF /i %radius% EQU 0 SET radius=1
echo R %radius%
rem pause

IF /i "%Oblateness%" NEQ "0" GOTO noOblat
    Lua lcalc.lua 1-(Ceiling(%radius%/5000000)/%radius%) > result.txt
    SET /p Oblateness= < result.txt
:noOblat
rem echo O %Oblateness%

Lua lcalc.lua (4/3*%pi%*(%cenRad%*1000*100)^^3*(1-%Oblateness%)*%mCM3%) > result.txt
IF /i "%RingCollector%" EQU "true" goto noCenRad
    Lua lcalc.lua (4/3*%pi%*(%radius%*1000*100)^^3*(1-%Oblateness%)*%mCM3%) > result.txt
:noCenRad
SET /p Mass2= < result.txt
rem echo M2 %Mass2%
rem pause

Lua lcalc.lua %Mass2%/%mEarth% > result.txt
SET /p mass= < result.txt

:start
SET oW=90
SET eW=90
SET e=0.0
SET /a i=%defInc%+(%iOff%*%rloop%)
SET /a eqnode=%eW%
Lua lcalc.lua Mod(%ow%+%i%,360) > result.txt
SET /p Obliqu= < result.txt
SET /a Obliqu=%Obliqu%+%oOffset%
rem echo Obliquity: %Obliqu%

SET /a ML=0
SET /a peri=0
SET /a M=0
SET /a node=0

Lua lcalc.lua sqrt(%a%^^3/(%Mass1%/%mSol%+%Mass2%/%mSol%)) > result.txt
SET /p Period= < result.txt

IF %defPeriod% NEQ 0 SET Period=%defPeriod%
    SET orbPeriod=%Period%
    SET prePeriod=%Period%
    Lua lcalc.lua %Period%*%daysYear%*24 > result.txt
    SET /p rotPeriod= < result.txt
    SET /a rotOffset=0
:noPerCalc

IF /i "%Class%" EQU "Terra" SET rotPeriod=0

SET loop=0
IF %rings% GTR 2 (
    Set /a cdivisor=%coldivisor%*2
    SET /a lend=%collectors%/cdivisor
) ELSE (
    SET /a lend=%collectors%/%coldivisor%
    SET rings=1
)

ECHO RLoop:	%rloop%

:BCenter
IF /i %rings% LEQ 2 GOTO loop
    ECHO.Asteroid "%DysonBubble%Core#%rloop%">>%FileName%.sc
    ECHO.{>>%FileName%.sc
    ECHO.    ParentBody  "%Dyson%">>%FileName%.sc
    ECHO.    Class       "Asteroid">>%FileName%.sc
    ECHO.    >>%FileName%.sc
    ECHO.    Radius      1.0>>%FileName%.sc
    ECHO.    >>%FileName%.sc
    ECHO.    Obliquity       %Obliqu% >>%FileName%.sc
    ECHO.    EqAscendNode    %ew% >>%FileName%.sc
    ECHO.    >>%FileName%.sc
    ECHO.    Surface>>%FileName%.sc
    ECHO.    {>>%FileName%.sc
    ECHO.        DiffMap        "Invisible.*">>%FileName%.sc
    ECHO.        DiffMapAlpha   "Transp">>%FileName%.sc
    ECHO.    }>>%FileName%.sc
    ECHO.    >>%FileName%.sc
    ECHO.    NoLighting      true>>%FileName%.sc
    ECHO.    >>%FileName%.sc
    ECHO.    StaticPosPolar  %PosPolar% >>%FileName%.sc
    ECHO.}>>%FileName%.sc
    ECHO.>>%FileName%.sc


:loop
IF /i %loop% EQU %lend% GOTO rloop
rem IF /i %rloop% GTR 0 IF %loop% EQU 0 Goto skipFL

:File
ECHO.%Object% "%Disc% %numb%">>%FileName%.sc
ECHO.{>>%FileName%.sc

IF /i %rings% GTR 2 (
    ECHO.    ParentBody  "%DysonBubble%Core#%rloop%">>%FileName%.sc
) ELSE (
    ECHO.    ParentBody  "%Dyson%">>%FileName%.sc
)

ECHO.    Class       "%Class%">>%FileName%.sc
ECHO.    >>%FileName%.sc

SET diskRad=%radius%

IF /i %rings% LEQ 2 GOTO noRadDisk
    Lua lcalc.lua %radius%*abs(cos((90-%M%)/180*%pi%)) > result.txt
    SET /p diskRad= < result.txt
:noRadDisk

echo %diskRad%

Lua lcalc.lua %diskRad%/(10*%AU%) > result.txt
SET /p CollOffset= < result.txt
Lua lcalc.lua %a%+%CollOffset% > result.txt
SET /p aPOff= < result.txt
rem Echo APOFF %aPOff%

IF /i "%RingCollector%" EQU "true" (
    ECHO.    Radius      %cenRad% >>%FileName%.sc
) ELSE (
    ECHO.    Radius      %diskRad% >>%FileName%.sc
)

ECHO.    Mass        %mass% >>%FileName%.sc
ECHO.    >>%FileName%.sc

IF /i "%FileName%" EQU "GabrialsHarp" (
    ECHO.    Oblateness  %Oblateness%    // 45   // >>%FileName%.sc
) ELSE (
    ECHO.    Oblateness  %Oblateness% >>%FileName%.sc
)

ECHO.    >>%FileName%.sc
ECHO.    Obliquity       %ow% >>%FileName%.sc
ECHO.    EqAscendNode    %eqnode% >>%FileName%.sc

IF /i %rings% GTR 2 (
    ECHO.    RotationPeriod  %rotPeriod% >>%FileName%.sc
    ECHO.    Precession      %prePeriod% >>%FileName%.sc
    REM ECHO.    RotationOffset  %M% >>%FileName%.sc
    ECHO.    RotationOffset  0 >>%FileName%.sc
    rem ECHO.    RotationOffset  45 >>%FileName%.sc
) ELSE (
    ECHO.    RotationPeriod  %rotPeriod% >>%FileName%.sc
    ECHO.    Precession      %prePeriod% >>%FileName%.sc
    ECHO.    RotationOffset  %rotOffset% >>%FileName%.sc
)

ECHO.    >>%FileName%.sc
ECHO.    Albedo      %Albedo%>>%FileName%.sc
ECHO.    Color       %Color%>>%FileName%.sc
REM ECHO.    Age       0.001>>%FileName%.sc
ECHO.    >>%FileName%.sc

IF /i "%Class%" EQU "Terra" (
    ECHO.    Life >>%FileName%.sc
    ECHO.    {>>%FileName%.sc
    ECHO.        Class   "Organic">>%FileName%.sc
    ECHO.        Type    "Multicellular">>%FileName%.sc
    ECHO.        Biome   "Marine/Terrestrial">>%FileName%.sc
    ECHO.    }>>%FileName%.sc
    ECHO.    >>%FileName%.sc
)

IF /i "%TidalLocked%" NEQ "NIL" (
    ECHO.    //%TidalLocked%>>%FileName%.sc
    ECHO.    >>%FileName%.sc
)

ECHO.    Surface>>%FileName%.sc
ECHO.    {>>%FileName%.sc

IF /i "%DiffMapAlpha%" NEQ "NIL" (
    ECHO.        %DiffMapAlpha%>>%FileName%.sc
)

IF /i "%DiffMap%" NEQ "NIL" (
    ECHO.        %DiffMap%>>%FileName%.sc
)

IF /i "%BumpMap%" NEQ "NIL" (
    ECHO.        %BumpMap%>>%FileName%.sc
    ECHO.        BumpHeight      50.0>>%FileName%.sc
    ECHO.        BumpOffset      25.0>>%FileName%.sc
)

IF /i "%GlowMap%" EQU "NIL" Goto noGlow
IF /i "%RingCollector%" EQU "true" Goto noGlow
    ECHO.        %GlowMap%>>%FileName%.sc
    ECHO.        GlowMode       %GlowMode%>>%FileName%.sc
    Rem ECHO.        GlowColor      (1.00 0.06 0.26)>>%FileName%.sc
    ECHO.        GlowColor      %GlowColor%>>%FileName%.sc
    ECHO.        GlowBright     %GlowBright%>>%FileName%.sc
:noGlow

IF /i "%Class%" NEQ "Terra" Goto noTerra
    ECHO.        BumpHeight      20 >>%FileName%.sc
    ECHO.        BumpOffset      7.2998 >>%FileName%.sc
    ECHO.        OceanStyle      0.6111111 >>%FileName%.sc
    ECHO.        SurfStyle       1 >>%FileName%.sc
    ECHO.        seaLevel        0.3968332 >>%FileName%.sc
    ECHO.        colorDistMagn   0.07749481 >>%FileName%.sc
    ECHO.        colorDistFreq   904.3558 >>%FileName%.sc
    ECHO.        riversMagn      61.905 >>%FileName%.sc
    ECHO.        riversFreq      6.5 >>%FileName%.sc
    ECHO.        montesMagn      0.600 >>%FileName%.sc
    ECHO.        mareFreq        0.001 >>%FileName%.sc
    ECHO.        mareDensity     0.000 >>%FileName%.sc
    ECHO.        Randomize       %Randomize% >>%FileName%.sc
:noTerra

IF /i "%RingCollector%" EQU "true" (
ECHO.    }>>%FileName%.sc
ECHO.    >>%FileName%.sc
ECHO.    Rings >>%FileName%.sc
ECHO.    {>>%FileName%.sc
ECHO.        InnerRadius %cenRad% >>%FileName%.sc
ECHO.        OuterRadius %radius% >>%FileName%.sc
ECHO.        Texture     "Collector-ring.*">>%FileName%.sc
)

ECHO.    }>>%FileName%.sc
ECHO.    >>%FileName%.sc

IF /i "%Class%" EQU "Terra" (
    ECHO.    Clouds >>%FileName%.sc
    ECHO.    {>>%FileName%.sc
    ECHO.        Height         1.983398 >>%FileName%.sc
    ECHO.        SpotBright     2.0 >>%FileName%.sc
    ECHO.        SpotWidth      0.15 >>%FileName%.sc
    ECHO.        DayAmbient     2.0 >>%FileName%.sc
    ECHO.        mainFreq       0.9442677 >>%FileName%.sc
    ECHO.        mainOctaves    10.0 >>%FileName%.sc
    ECHO.        Coverage       0.2172414 >>%FileName%.sc
    ECHO.        twistZones     1.0 >>%FileName%.sc
    ECHO.        twistMagn      0.2500089 >>%FileName%.sc
    ECHO.        }>>%FileName%.sc
    ECHO.     >>%FileName%.sc
    ECHO.    Ocean >>%FileName%.sc
    ECHO.    {>>%FileName%.sc
    ECHO.        Height     7.299805 >>%FileName%.sc
    ECHO.        Hapke      0.0 >>%FileName%.sc
    ECHO.        SpotBright 2.0 >>%FileName%.sc
    ECHO.        SpotWidth  0.15 >>%FileName%.sc
    ECHO.        DayAmbient 2.0 >>%FileName%.sc
    ECHO.    }>>%FileName%.sc
    ECHO.    >>%FileName%.sc
)

ECHO.    NoClouds       %NoClouds%>>%FileName%.sc
ECHO.    NoOcean        %NoOcean%>>%FileName%.sc
ECHO.    NoLava         %NoLava%>>%FileName%.sc
ECHO.    NoAtmosphere   %NoAtmosphere%>>%FileName%.sc
ECHO.    NoAurora       %NoAurora%>>%FileName%.sc

IF /i "%RingCollector%" EQU "true" (
    ECHO.    NoRings        false>>%FileName%.sc
) ELSE (
    ECHO.    NoRings        %NoRings%>>%FileName%.sc
)

ECHO.    NoCometTail    %NoCometTail%>>%FileName%.sc
ECHO.    NoLighting     %NoLighting%>>%FileName%.sc

IF /i "%Class%" EQU "Terra" (
    ECHO.    >>%FileName%.sc
    ECHO.    Atmosphere >>%FileName%.sc
    ECHO.    {>>%FileName%.sc
    ECHO.        Model      "Earth">>%FileName%.sc
    ECHO.        Height     105.6354 >>%FileName%.sc
    ECHO.        Density    0.9295098 >>%FileName%.sc
    ECHO.        Pressure   1.075836 >>%FileName%.sc
    REM ECHO.        Greenhouse 55.55556 >>%FileName%.sc
    ECHO.        Greenhouse 129.999 >>%FileName%.sc
    ECHO.        Bright     10.31746 >>%FileName%.sc
    ECHO.        Opacity    0.5079365 >>%FileName%.sc
    ECHO.        SkyLight   2.936508 >>%FileName%.sc
    ECHO.    }>>%FileName%.sc
)

ECHO.    >>%FileName%.sc
ECHO.    Orbit>>%FileName%.sc
ECHO.    {>>%FileName%.sc

rem Lua lcalc.lua Mod(%numb%,2) > result.txt
rem SET /p reslt= < result.txt 
rem IF /i %reslt% EQU 1 (
    rem Echo %reslt%
rem     ECHO.        SemiMajorAxis  %aPOff% >>%FileName%.sc
rem ) ELSE (
    rem Echo %reslt%
    ECHO.        SemiMajorAxis  %a% >>%FileName%.sc
rem )

IF /i %rings% GTR 2 (
    rem ECHO.        Period         %orbPeriod% >>%FileName%.sc
    ECHO.        Period         1e12>>%FileName%.sc
    ECHO.        Inclination    0.0>>%FileName%.sc
) ELSE (
    ECHO.        Period         %orbPeriod% >>%FileName%.sc
    REM ECHO.        Inclination    %i% >>%FileName%.sc
    ECHO.        Inclination    0.0 >>%FileName%.sc
)

ECHO.        Eccentricity   %e% >>%FileName%.sc
ECHO.        MeanAnomaly    %M% >>%FileName%.sc
ECHO.        RefPlane       "%RefPlane%">>%FileName%.sc
ECHO.    }>>%FileName%.sc
ECHO.}>>%FileName%.sc
ECHO.>>%FileName%.sc


:skipFL
Lua lcalc.lua %M%+%angle% > result.txt
SET /p M= < result.txt
Lua lcalc.lua Mod(%M%+%eW%,360) > result.txt
SET /p eqnode= < result.txt

SET /a loop=%loop%+1
SET /a numb=%numb%+1
REM SET /a numOfCollectors=%numOfCollectors%+1

SET dots=%dots%.
SET /a idx=%idx%+1
IF %idx% EQU 10 (
    ECHO %dots%
    SET dots=.
    SET idx=1
)

GOTO loop

:rloop
SET /a rloop=%rloop%+1

ECHO.//------------------------------------------------------------------------------>>%FileName%.sc

IF /i %rloop% EQU %rings% GOTO ende
rem exit
GOTO start

:ende
ECHO %dots%
ECHO %SE_CATALOGS%
rem TYPE %FileName%.sc > "%SE_CATALOGS%\%FileName%.sc"

Lua lcalc.lua %distKm%+(%pDist%*3) > result.txt
SET /p distKm= < result.txt
SET POS=Aussen
IF /i "%DysonBubble%" EQU "%Dyson%InnenRinG" GOTO TheRing

DEL /Q result.txt
rem CD /D %SPACEENGINES%\SpaceEngine 0.980\system\
REM START SE_0980.bat -skipall

ECHO Fertig.

